class ActiveAttack::MatricesController < ApplicationController
  before_action :set_matrix, only: [:show, :edit, :update, :destroy, :data]

  # GET /attack/matrices
  # GET /attack/matrices.json
  def index
    @attack_matrices = ActiveAttack::Matrix.all
  end

  # GET /attack/matrices/1
  # GET /attack/matrices/1.json
  def show
    @attack_matrix = ActiveAttack::Matrix.find(params[:id])
  end


  # GET /attack/matrices/new
  def new
    @attack_matrix = ActiveAttack::Matrix.new
  end

  # GET /attack/matrices/1/edit
  def edit
  end

  def data
  end

  # POST /attack/matrices
  # POST /attack/matrices.json
  def create
    @attack_matrix = ActiveAttack::Matrix.new(attack_matrix_params)

    respond_to do |format|
      if @attack_matrix.save
        bundle = @attack_matrix.ingest_bundle(params[:attack_matrix][:uploaded_file].path)
        @attack_matrix.update(:stix_bundle_id => bundle.stix_id)
        format.html { redirect_to @attack_matrix, notice: 'Attack matrix was successfully created.' }
        format.json { render :show, status: :created, location: @attack_matrix }
      else
        format.html { render :new }
        format.json { render json: @attack_matrix.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /stix/matrices/1
  # PATCH/PUT /stix/matrices/1.json
  def update
    respond_to do |format|
      if @attack_matrix.update(attack_attack_matrix_params)
        format.html { redirect_to @attack_matrix, notice: 'Attack matrix was successfully updated.' }
        format.json { render :show, status: :ok, location: @attack_matrix }
      else
        format.html { render :edit }
        format.json { render json: @attack_matrix.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /attack/matrices/1
  # DELETE /attack/matrices/1.json
  def destroy
    @attack_matrix.destroy
    respond_to do |format|
      format.html { redirect_to attack_attack_matrices_url, notice: 'Attack matrix was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_matrix
      #@attack_pattern = ActiveStix::AttackPattern.find(params[:id])
      @matrix = ActiveAttack::Matrix.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def attack_matrix_params
      params.require(:attack_matrix).permit(:stix_bundle_id, :name)
    end
end
