class ActiveAttack::PlaybooksController < ApplicationController
  before_action :set_attack_playbook, only: [:edit, :update, :destroy]

  # GET /attack/playbooks
  # GET /attack/playbooks.json
  def index
    @playbooks = ActiveAttack::Playbook.all
  end

  # GET /attack/playbooks/1
  # GET /attack/playbooks/1.json
  def show
    # @attack_playbook.stix_bundle.bundled_objects.each do | x |
    #   render :json => @attack_playbook.stix_bundle
    # end
    @playbooks = ActiveAttack::Playbook.all
    @threat_actor = ActiveStix::ThreatActor.find(params[:id])
    @playbook = @threat_actor.playbook
    @report = @playbook.bundle

    respond_to do |format|
      format.html
      format.json {render json: @playbook.as_stix}
    end
  end

  # GET /attack/playbooks/new
  def new
    @attack_playbook = ActiveAttack::Playbook.new
  end

  # GET /attack/playbooks/1/edit
  def edit
  end

  # POST /attack/playbooks
  # POST /attack/playbooks.json
  def create
    @attack_playbook = ActiveAttack::Playbook.new(attack_playbook_params)

    respond_to do |format|
      if @attack_playbook.save
        bundle = @attack_playbook.ingest_bundle(params[:attack_playbook][:uploaded_file].path)
        @attack_playbook.update(:stix_bundle_id => bundle.stix_id)
        format.html { redirect_to @attack_playbook, notice: 'Playbook was successfully created.' }
        format.json { render :show, status: :created, location: @attack_playbook }
      else
        format.html { render :new }
        format.json { render json: @attack_playbook.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /attack/playbooks/1
  # PATCH/PUT /attack/playbooks/1.json
  def update
    respond_to do |format|
      if @attack_playbook.update(attack_playbook_params)
        format.html { redirect_to @attack_playbook, notice: 'Playbook was successfully updated.' }
        format.json { render :show, status: :ok, location: @attack_playbook }
      else
        format.html { render :edit }
        format.json { render json: @attack_playbook.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /attack/playbooks/1
  # DELETE /attack/playbooks/1.json
  def destroy
    @attack_playbook.destroy
    respond_to do |format|
      format.html { redirect_to attack_playbooks_url, notice: 'Playbook was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_attack_playbook
    @attack_playbook = ActiveAttack::Playbook.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def attack_playbook_params
    params.require(:attack_playbook).permit(:name, :stix_bundle_id, :id)
  end
end
