require_dependency "active_attack/application_controller"

module ActiveAttack
  class TacticsController < ApplicationController
    before_action :set_tactic, only: [:show, :edit, :update, :destroy]

    # GET /tactics
    def index
      @tactics = Tactic.all
    end

    # GET /tactics/1
    def show
    end

    # GET /tactics/new
    def new
      @tactic = Tactic.new
    end

    # GET /tactics/1/edit
    def edit
    end

    # POST /tactics
    def create
      @tactic = Tactic.new(tactic_params)

      if @tactic.save
        redirect_to @tactic, notice: 'Tactic was successfully created.'
      else
        render :new
      end
    end

    # PATCH/PUT /tactics/1
    def update
      if @tactic.update(tactic_params)
        redirect_to @tactic, notice: 'Tactic was successfully updated.'
      else
        render :edit
      end
    end

    # DELETE /tactics/1
    def destroy
      @tactic.destroy
      redirect_to tactics_url, notice: 'Tactic was successfully destroyed.'
    end

    private
      # Use callbacks to share common setup or constraints between actions.
      def set_tactic
        @tactic = Tactic.find(params[:id])
      end

      # Only allow a trusted parameter "white list" through.
      def tactic_params
        params.require(:tactic).permit(:stix_id, :name, :description, :shortname, :created_by_ref)
      end
  end
end
