ActiveStix::AttackPattern.class_eval do


  def expected_keys
    [
        'external_references',
        'kill_chain_phases',
        'object_marking_refs',
        'x_mitre_detection',
        'x_mitre_data_sources',
        'x_mitre_platforms',
        'x_mitre_permissions_required',
        'x_mitre_detectable_by_common_defenses',
        'x_mitre_difficulty_for_adversary_explanation',
        'x_mitre_difficulty_for_adversary',
        'x_mitre_detectable_by_common_defenses_explanation',
        'x_mitre_version'
    ]
  end


  def self.x_mitre_detection(attack_pattern, ob)
    xmd = ActiveAttack::Detection.create_descr(obj['x_mitre_detection'])
    #ensure no duplicate entries
    attack_pattern.detections << xmd unless ActiveAttack::DetectionAttackPattern.find_by(x_mitre_detection_id: xmd.id, attack_pattern_id: attack_pattern.id)
  end

  def self.x_mitre_data_sources(attack_pattern, obj)
    obj['x_mitre_data_sources'].each do |ds|
      d_source = ActiveAttack::DataSource.create_source(ds)
      attack_pattern.data_sources << d_source unless ActiveAttack::DataSourceAttackPattern.find_by(data_source_id: d_source.id, attack_pattern_id: attack_pattern.id)
    end
  end

  def self.x_mitre_platforms(attack_pattern, obj)
    obj['x_mitre_platforms'].each do |plat|
      platform = ActiveAttack::Platform.create_platform(plat)
      attack_pattern.platforms << platform unless ActiveAttack::PlatformAttackPattern.find_by(platform_id: platform.id, attack_pattern_id: attack_pattern.id)
    end
  end


  def self.x_mitre_permissions_required(attack_pattern, obj)
    obj['x_mitre_permissions_required'].each do |perm|
      permission = ActiveAttack::PermissionsRequired.create_perm(perm)
      attack_pattern.permissions_requireds << permission unless ActiveAttack::PermissionsRequiredAttackPattern.find_by(permissions_required_id: permission.id, attack_pattern_id: attack_pattern.id)
    end
  end

  def self.x_mitre_detectable_by_common_defenses(attack_pattern, obj)
    det = ActiveAttack::DetectableByCommonDefense.create_detectable(obj['x_mitre_detectable_by_common_defenses'])
    attack_pattern.detectable_by_common_defenses << det unless ActiveAttack::DetectableByCommonDefenseAttackPattern.find_by(detectable_by_common_defense_id: det.id, attack_pattern_id: attack_pattern.id)
  end

  def self.x_mitre_difficulty_for_adversary_explanation(attack_pattern, obj)
    diff_exp = ActiveAttack::DifficultyForAdversaryExplanation.create_explanation(obj['x_mitre_difficulty_for_adversary_explanation'])
    attack_pattern.difficulty_for_adversary_explanations << diff_exp unless ActiveAttack::DifficultyForAdversaryExplanationAttackPattern.find_by(difficulty_for_adversary_id: diff_exp.id, attack_pattern_id: attack_pattern.id)
  end

  def self.x_mitre_difficulty_for_adversary(attack_pattern, obj)
    diff = ActiveAttack::DifficultyForAdversary.create_difficulty(obj['x_mitre_difficulty_for_adversary'])
    attack_pattern.difficulty_for_adversaries << diff unless ActiveAttack::DifficultyForAdversaryAttackPattern.find_by(difficulty_for_adversary_id: diff.id, attack_pattern_id: attack_pattern.id)
  end

  def self.x_mitre_detectable_by_common_defenses_explanation(attack_pattern, obj)
    det_exp = ActiveAttack::DetectableByCommonDefensesExplanation.create_explanation(obj['x_mitre_detectable_by_common_defenses_explanation'])
    attack_pattern.detectable_by_common_defenses_explanations << det_exp unless ActiveAttack::DetectableByCommonDefensesExplanationAttackPattern.find_by(detectable_by_common_defenses_explanation_id: det_exp.id, attack_pattern_id: attack_pattern.id)
  end

  def self.x_mitre_version(attack_pattern, obj)
    version = ActiveAttack::Version.create_version(obj['x_mitre_version'])
    attack_pattern.versions << version unless ActiveAttack::VersionAttackPattern.find_by(version_id: version.id, attack_pattern_id: attack_pattern.id)
  end

end