ActiveStix::Tool.class_eval do
  has_many :builds, class_name: "ActiveAttack::Build", as: :buildable
  has_many :platforms, through: :builds, class_name: "ActiveAttack::Platform"

  def self.expected_keys
    [
        'description',
        'external_references',
        'object_marking_refs',
        'x_mitre_aliases',
        'x_mitre_platforms',
        'labels',
        'x_mitre_version'
    ]
  end


  def self.x_mitre_aliases(tool, obj)
    tool.aliases = obj['x_mitre_aliases']
  end

  def self.x_mitre_platforms(tool, obj)
    obj['x_mitre_platforms'].each do |plat|
      platform = ActiveAttack::Platform.create_platform(plat)
      # todo make sure these are stix_ids
      tool.platforms << platform unless ActiveAttack::Build.find_by(platform_id: platform.id, buildable_id: tool.id)
    end
  end

  def self.x_mitre_version(tool, obj)
    # todo
    # version = ActiveAttack::Version.create_version(obj['x_mitre_version'])
    # tool.versions << version unless ActiveAttack::ToolVersion.find_by(version_id: version.id, tool_id: tool.id)
  end

end